/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <kapplication.h>
#include <kcmdlineargs.h>
#include <kaboutdata.h>

#include "lib/TrafficWindow.h"

#include "KTASettings.h"

int main( int argc, char **argv ) {
	KAboutData aboutData( "KTrafficAnalyzer", "KTrafficAnalyzer",
			ki18n("KTrafficAnalyzer"), versionString,
			ki18n("Network monitoring software."),
			KAboutData::License_GPL_V2,
			ki18n("Copyright (c) 2009 Wolfgang 'Viras' Koller"),
                        ki18n(""),
                        "https://sourceforge.net/projects/ktrafficanalyze/"
                );
        aboutData.setProgramIconName( "network-workgroup" );

	KCmdLineArgs::init( argc, argv, &aboutData );

        // Create application object & main window
	KApplication app;
	QWidget *mainWindow = new TrafficWindow();

        // Check if we should start minimized
	if( KTASettings::startMinimized() ) {
		mainWindow->hide();
	}
	else {
		mainWindow->show();
	}

	return app.exec();
}
