#
# spec file for package KTrafficAnalyzer (Version 0.5.4)
#
# Copyright 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
# Copyright Wolfgang 'Viras' Koller <viras@users.sourceforge.net>
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

%define setupversion 0.5.4.1

Summary: KDE Tool for providing visual feedback of the current network traffic
Name: KTrafficAnalyzer
Version: %{setupversion}
Release: 1
License: GPLv2+
Group: System/Monitoring
Source: %{name}-%{setupversion}.tar.bz2
BuildRoot: %{_tmppath}/build-%{name}-%{version}
BuildRequires: libkde4-devel libqt4-devel
Packager: Wolfgang Koller <viras@users.sourceforge.net>
Patch0: openSUSE_11.0.patch
%kde4_runtime_requires

%description
KTrafficAnalyzer is a KDE Tool designed to provide visual feedback of the current network traffic, similar to tools like e.g. DU Meter.

%prep
%setup -n "%{name}-%{setupversion}"
%if %suse_version <= 1100
%patch0
%endif

%build
%cmake_kde4
%__make

%install
%if %suse_version <= 1100
make DESTDIR=%{?buildroot:%{buildroot}} install/fast
%else
%kde4_makeinstall
%endif
%__ln_s "ktrafficanalyzer" "%{buildroot}%{_bindir}/KTrafficAnalyzer"
%kde_post_install

%files
%defattr(-,root,root)
%{_bindir}/KTrafficAnalyzer
%{_bindir}/ktrafficanalyzer
%{_datadir}/applications/kde4/ktrafficanalyzer.desktop

%changelog
* Mon Aug 02 2010 Wolfgang Koller <viras@users.sourceforge.net> 0.5.4.1
- Release 0.5.4.1

* Sat Jul 31 2010 Wolfgang Koller <viras@users.sourceforge.net> 0.5.4
- Release 0.5.4

* Thu Dec 10 2009 Wolfgang Koller <viras@users.sourceforge.net> 0.5.3
- Release 0.5.3

* Tue Nov 17 2009 Wolfgang Koller <viras@users.sourceforge.net> 0.5.3
- Update spec file to report no warnings anymore
