/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             *
 *                                                                         *
 ***************************************************************************/

#ifndef KTASYSTRAY
#define KTASYSTRAY

#include <ksystemtrayicon.h>
#include <kiconloader.h>
#include <klocalizedstring.h>

#include <QtGui/QToolTip>

class KTASysTray : public KSystemTrayIcon {
    Q_OBJECT

public:
    KTASysTray(QWidget* parent = 0, const char* name = 0);
    ~KTASysTray();

    void setInterfaceName(QString interfaceName);
    void updateTraffic(QString downTraffic, QString upTraffic);

    void updateInterfaces(QStringList, QString); // Called when the quick selection menu for the interfaces should be updated

private slots:
    void interfaceEntryTriggered(QAction*);

signals:
    void interfaceChanged(QString);

private:
    QString interfaceName;
    QMenu *interfaceMenu;
};

#endif
