/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the Free Software           *
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             *
 *                                                                         *
 ***************************************************************************/

#ifndef SSHTRAFFICINTERFACE_H_
#define SSHTRAFFICINTERFACE_H_

#include "../settings/KTASettings.h"

#include "TrafficInterface.h"
#include "remoteRead.h"

class SSHTrafficInterface : public TrafficInterface {
	public:
		SSHTrafficInterface();
		~SSHTrafficInterface();

		int readTrafficDiff( char * );	//Read traffic differences for interface interfaceName
		QStringList getInterfaces();	//Get a list of all available interfaces
		QString getInterfaceName();		//Get interface name (set by last call of readTrafficDiff)

		void setDebug( bool );			//Update Debug-Settings

	protected:
		remoteRead *sshConsole;
		QString sshHost;
};

#endif /*SSHTRAFFICINTERFACE_H_*/
