/*
 * File:   InterfaceWidget.cpp
 * Author: wkoller
 *
 * Created on 12. November 2009, 19:00
 */

#include "InterfaceWidget.h"
#include "InterfaceWidget.moc"

InterfaceWidget::InterfaceWidget( QWidget *parent ) : QWidget( parent ) {
    this->setupUi( this );

    this->kcfg_Interface->setVisible( false );
}

void InterfaceWidget::loadInterfaces( int itemIndex ) {
    this->on_kcfg_interfacesSource_activated( itemIndex );
}

void InterfaceWidget::on_kcfg_interfacesSource_activated(int itemIndex) {
    //Get correct traffic interface
    TrafficInterface *tI = TrafficInterface::spawnTrafficInterface(itemIndex);
    //Clean Interfaces list
    this->InterfaceNum->clear();
    //Get list of interfaces
    QStringList interfaces = tI->getInterfaces();
    //Add interfaces to list
    /*for ( QStringList::Iterator it = interfaces.begin(); it != interfaces.end(); ++it ) {
            ui.InterfaceNum->insertItem( *it );
    }*/
    this->InterfaceNum->insertItems(0, interfaces);

    this->InterfaceNum->setCurrentItem( KTASettings::interface() );

    //Delete object to save up some memory
    delete tI;
}