/****************************************************************************
** Form implementation generated from reading ui file 'settings_traffic.ui'
**
** Created: Fr Feb 18 21:31:01 2005
**      by: The User Interface Compiler ($Id: TrafficStatsWidget.cpp,v 1.1.1.1 2009/10/30 16:25:40 viras Exp $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "TrafficStatsWidget.h"
#include "TrafficStatsWidget.moc"

/*
 *  Constructs a TrafficStatsWidget as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
TrafficStatsWidget::TrafficStatsWidget( QWidget* parent, Qt::WindowFlags fl )
    : QWidget( parent, fl )
{
    trafficTable = new Q3Table( this, "trafficTable" );
    trafficTable->setNumCols( 3 );
    trafficTable->horizontalHeader()->setLabel( 0, tr( "Upload" ) );
    trafficTable->horizontalHeader()->setLabel( 1, tr( "Download" ) );
    trafficTable->horizontalHeader()->setLabel( 2, tr( "Total" ) );
    trafficTable->setGeometry( QRect( 10, 10, 400, 320 ) );
    trafficTable->setEnabled( TRUE );
    trafficTable->setShowGrid( TRUE );
    trafficTable->setReadOnly( TRUE );

    //Create reset button
    resetButton = new QPushButton( this );
    resetButton->setText( "Clear stats" );
    resetButton->setGeometry( QRect( 10, 335, 100, 20 ) );
    QObject::connect( resetButton, SIGNAL( pressed() ), this, SLOT( resetStats() ) );

    //Create export button
    exportButton = new QPushButton( this );
    exportButton->setText( "Export" );
    exportButton->setGeometry( QRect( 120, 335, 100, 20 ) );
    QObject::connect( exportButton, SIGNAL( pressed() ), this, SLOT( exportStats() ) );

    setFixedSize( 420, 360 );

    readStats();
}

/*
 *  Destroys the object and frees any allocated resources
 */
TrafficStatsWidget::~TrafficStatsWidget()
{
    // no need to delete child widgets, Qt does it all for us
}

void TrafficStatsWidget::showEvent( QShowEvent *event ) {
	readStats();

	//Make sure last item is shown
	trafficTable->ensureCellVisible( trafficTable->numRows() - 1, 1 );
}

void TrafficStatsWidget::updateStats( int dateIndex ) {
	QStringList uploads( KTAStats::uploads() );
	QStringList downloads( KTAStats::downloads() );

	//Check if date does not exist yet
	if( trafficTable->numRows() <= dateIndex ) {
		trafficTable->setNumRows( dateIndex + 1 );
		trafficTable->setText( dateIndex, 0, getFormattedValue( uploads[dateIndex].toFloat() ) );
		trafficTable->setText( dateIndex, 1, getFormattedValue( downloads[dateIndex].toFloat() ) );
		trafficTable->setText( dateIndex, 2, getFormattedValue( downloads[dateIndex].toFloat() + uploads[dateIndex].toFloat() ) );
	}
	//... just update the values
	else {
		trafficTable->setText( dateIndex, 0, getFormattedValue( uploads[dateIndex].toFloat() ) );
		trafficTable->setText( dateIndex, 1, getFormattedValue( downloads[dateIndex].toFloat() ) );
		trafficTable->setText( dateIndex, 2, getFormattedValue( downloads[dateIndex].toFloat() + uploads[dateIndex].toFloat() ) );
	}
}

void TrafficStatsWidget::resetStats() {
	if( KMessageBox::questionYesNo( this, "Are you sure you want to reset the stats? All collected data will be lost!", "Question" ) != KMessageBox::Yes ) {
		return;
	}

	KTAStats::self()->setDefaults();
	KTAStats::self()->writeConfig();
	updateStats(0);
}

//Export stats to a file
void TrafficStatsWidget::exportStats() {
	//Get filename to save to
	QString fileName = KFileDialog::getSaveFileName( KUrl(), "*.csv|CSV Files", this );
	if( fileName.isEmpty() ) {
		return;
	}

	//Open file for writing
	QFile outFile( fileName );
	if( outFile.open( QIODevice::WriteOnly ) ) {
		//Create output stream
		QTextStream outStream( &outFile );

		//Write header
		outStream << "Date;Upload;Download;Total\n";
		//Write data
		for( int i = 0; i < trafficTable->numRows(); i++ ) {
			outStream << trafficTable->verticalHeader()->label( i ) << ";";
			outStream << trafficTable->text( i, 0 ).replace( '.', ',' ) << ";";
			outStream << trafficTable->text( i, 1 ).replace( '.', ',' ) << ";";
			outStream << trafficTable->text( i, 2 ).replace( '.', ',' ) << "\n";
		}
		outFile.close();
	}
	else {
		KMessageBox::error( this, "Couldn't write to file: " + outFile.errorString() + "!", "Error" );
	}
}

void TrafficStatsWidget::readStats() {
    //Get information
    QStringList dates( KTAStats::dates() );
    QStringList uploads( KTAStats::uploads() );
    QStringList downloads( KTAStats::downloads() );

    //Set table
    trafficTable->setNumRows( dates.count() );

    //Insert stats data
    for( int i = 0; i < dates.count(); i++ ) {
    	trafficTable->verticalHeader()->setLabel( i, dates[i] );
    	trafficTable->setText( i, 0, getFormattedValue( uploads[i].toFloat() ) );
	trafficTable->setText( i, 1, getFormattedValue( downloads[i].toFloat() ) );
	trafficTable->setText( i, 2, getFormattedValue( downloads[i].toFloat() + uploads[i].toFloat() ) );
    }
}

//Returns correctly formatted number
QString TrafficStatsWidget::getFormattedValue( float value ) {
	//G-Bytes
	if( (value / 1024000000.0) > 1.0 ) {
		return( QString::number( (value / 1024000000.0), 'f', 3 ).append( " GB" ) );
	}
	//M-Bytes
	else if( (value / 1024000.0) > 1.0 ) {
		return( QString::number( (value / 1024000.0), 'f', 3 ).append( " MB" ) );
	}
	//K-Bytes
	else if( (value / 1024.0) > 1.0 ) {
		return( QString::number( (value / 1024.0), 'f', 3 ).append( " KB" ) );
	}
	else {
		return( QString::number( value ).append( " B" ) );
	}
}
